procedure CreateMenuContextDialog;
var
  i : Integer;
begin
  Menu := CreatePopupMenu;
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_ABOUTINFO, @MenuItems[1]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_TRAYADDDEL, @MenuItems[5]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_EQUALIZER, @MenuItems[6]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_CREATESTAT, @MenuItems[8]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_RENAMESTAT, @MenuItems[9]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_REMOVESTAT, @MenuItems[10]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_RELOADLIST, @MenuItems[11]);
  AppendMenu(Menu, MF_SEPARATOR, 0,nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_SETTINGS, @MenuItems[7]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_URLLINK, @MenuItems[13]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STARTPLAY, @MenuItems[14]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STOPPLAY, @MenuItems[15]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STARTRECORD, @MenuItems[16]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STOPRECORD, @MenuItems[17]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_DIRECTORY, @MenuItems[18]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_EXITAPP, @MenuItems[19]);
  SetForegroundWindow(hApp);
  GetCursorPos(pt);
  TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON, pt.x, pt.y, 0, hApp, nil);
  PostMessage(hApp, WM_NULL, 0, 0);
  DestroyMenu(Menu);
  for i := 1 to 19 do if MenuItems[i].icon <> 0 then DeleteObject(MenuItems[i].icon);
end;

procedure CreateMenuContextListview;
var
  i : Integer;
begin
  Menu := CreatePopupMenu;
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_CREATESTAT, @MenuItems[8]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_RENAMESTAT, @MenuItems[9]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_REMOVESTAT, @MenuItems[10]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_RELOADLIST, @MenuItems[11]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_URLLINK, @MenuItems[13]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STARTPLAY, @MenuItems[14]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STOPPLAY, @MenuItems[15]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STARTRECORD, @MenuItems[16]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_STOPRECORD, @MenuItems[17]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_DIRECTORY, @MenuItems[18]);
  SetForegroundWindow(hApp);
  GetCursorPos(pt);
  TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON, pt.x, pt.y, 0, hApp, nil);
  PostMessage(hApp, WM_NULL, 0, 0);
  DestroyMenu(Menu);
  for i := 1 to 19 do if MenuItems[i].icon <> 0 then DeleteObject(MenuItems[i].icon);
end;

procedure CreateMenuToolbar;
var
  i : Integer;
begin
  Menu := CreatePopupMenu;
  GetWindowRect(GetDlgItem(hApp, CTRL_TOOLBAR_GENERAL), Rect);
  pt.x := Rect.Left;
  pt.y := Rect.Bottom;
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_ABOUTINFO, @MenuItems[1]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_FORUM, @MenuItems[2]);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_MESSAGE, @MenuItems[3]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_UPDATE, @MenuItems[4]);
  SetForegroundWindow(hApp);
  TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON, pt.x, pt.y, 0, hApp, nil);
  PostMessage(hApp, WM_NULL, 0, 0);
  DestroyMenu(Menu);
  for i := 1 to 19 do if MenuItems[i].icon <> 0 then DeleteObject(MenuItems[i].icon);
end;

procedure FindPlugIn;
type
  TNamePlugin = function : PChar; stdCall;
var
  StationList : PStationList;
begin
  GetMem(StationList, SizeOf(StationList));
  ZeroMemory(StationList, SizeOf(StationList));
  if GetPrivateProfileString(PChar('Stations'), nil, nil, buffer3, SizeOf(buffer3), PChar(GetCurDir + 'Stations.dat')) <> 0 then
    begin
      ListStat := buffer3;
      while ListStat^ <> EmptyStr do
        begin
          New(ArrayStationList[PluginID]);
          ArrayStationList[PluginID].ID := PluginID;
          ArrayStationList[PluginID].Name := PChar(ListStat);
          Inc(PluginID);
          Inc(ListStat, lstrlen(ListStat) + 1);
        end;
    end;
  FreeMem(StationList, SizeOf(StationList));
end;

procedure CreateMenuTrayIcon;
var
  i, ListIndx : Integer;
begin
  Menu := CreatePopupMenu;
  if IsWindowEnabled(hAbt) or
    IsWindowEnabled(hStg) or
      IsWindowEnabled(hLst) or
        IsWindowEnabled(hInf) or
          IsWindowEnabled(FindWindow(nil, PChar(LoadStr(IDC_STR_MSG_ERR)))) or
            IsWindowEnabled(FindWindow(nil, PChar(LoadStr(STR_TIP_ICONTRAY))))
              then Exit;
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_ABOUTINFO, @MenuItems[1]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_TRAYADDDEL, @MenuItems[5]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  SubMenu := CreatePopUpMenu();

  for ListIndx := MinStatList to MaxStatList do if ArrayStationList[ListIndx] <> nil then
    AppendMenu(SubMenu, MF_BYPOSITION, ArrayStationList[ListIndx].ID, PChar(ArrayStationList[ListIndx].Name));



  AppendMenu(Menu, MF_OWNERDRAW or MF_POPUP, SubMenu, @MenuItems[12]);
  DestroyMenu(SubMenu);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_SETTINGS, @MenuItems[7]);
  AppendMenu(Menu, MF_SEPARATOR, 0, nil);
  AppendMenu(Menu, MF_OWNERDRAW, CTRL_MENU_EXITAPP, @MenuItems[19]);
  SetForegroundWindow(hApp);
  GetCursorPos(pt);
  TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON, pt.x, pt.y, 0, hApp, nil);
  PostMessage(hApp, WM_NULL, 0, 0);
  DestroyMenu(Menu);
  for i := 1 to 19 do if MenuItems[i].icon <> 0 then DeleteObject(MenuItems[i].icon);
end;

procedure CreateMenuItemsIcons;
begin
  MenuItems[1].icon := LoadImage(hInstance, PChar(RES_ICON_MENUABOUT), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[2].icon := LoadImage(hInstance, PChar(RES_ICON_MENUFORUM), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[3].icon := LoadImage(hInstance, PChar(RES_ICON_MENUMESSAGE), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[4].icon := LoadImage(hInstance, PChar(RES_ICON_MENUUPDATE), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[5].icon := LoadImage(hInstance, PChar(RES_ICON_MENUTRAYICON), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[6].icon := LoadImage(hInstance, PChar(RES_ICON_MENUEQUALIZER), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[7].icon := LoadImage(hInstance, PChar(RES_ICON_MENUSETTINGS), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[8].icon := LoadImage(hInstance, PChar(RES_ICON_MENUSTATADD), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[9].icon := LoadImage(hInstance, PChar(RES_ICON_MENUSTATREN), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[10].icon := LoadImage(hInstance, PChar(RES_ICON_MENUSTATDEL), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[11].icon := LoadImage(hInstance, PChar(RES_ICON_MENUSTATREL), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[12].icon := LoadImage(hInstance, PChar(RES_ICON_STATIONS), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[13].icon := LoadImage(hInstance, PChar(RES_ICON_MENUPLAYURL), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[14].icon := LoadImage(hInstance, PChar(RES_ICON_MENUPLAYSTART), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[15].icon := LoadImage(hInstance, PChar(RES_ICON_MENUPLAYSTOP), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[16].icon := LoadImage(hInstance, PChar(RES_ICON_MENURECSTART), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[17].icon := LoadImage(hInstance, PChar(RES_ICON_MENURECSTOP), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[18].icon := LoadImage(hInstance, PChar(RES_ICON_MENUDIRECTORY), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[19].icon := LoadImage(hInstance, PChar(RES_ICON_MENUEXITAPP), IMAGE_ICON, 16, 16, LR_DEFAULTSIZE or LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  MenuItems[1].text := PChar('  ');
  MenuItems[2].text := PChar('  ');
  MenuItems[3].text := PChar(' ');
  MenuItems[4].text := PChar(' ');
  MenuItems[5].text := PChar(' / ');
  MenuItems[6].text := PChar('  ');
  MenuItems[7].text := PChar(' ');
  MenuItems[8].text := PChar('  [Ins]');
  MenuItems[9].text := PChar('  [F2]');
  MenuItems[10].text := PChar('  [Del]');
  MenuItems[11].text := PChar('  [F5]');
  MenuItems[12].text := PChar(' ');
  MenuItems[13].text := PChar(' URL ');
  MenuItems[14].text := PChar(' ');
  MenuItems[15].text := PChar(' ');
  MenuItems[16].text := PChar(' ');
  MenuItems[17].text := PChar(' ');
  MenuItems[18].text := PChar(' ');
  MenuItems[19].text := PChar('  ');
end;
